#include <iostream>
#include <fstream>
using namespace std;

ifstream f("mugurita.in");
ofstream g("mugurita.out");

int n, m, z, c, x, y;

/// Complexitate: O(N)
pair < int, int > offsets[6] = {{-1, 2}, {-2, 0}, {-1, -2}, {1, -2}, {2, 0}, {1, 2}};

void solve_1() {
    f >> z;
    int a = 0, b = 0;
    int r = 1;
    while (z) {
        a += 1; b += 2; z--;
        for (int edge=0;edge<6 && z;edge++) {
            for (int i=1; (i<(r + (edge != 0)) && z); i++) {
                a += offsets[edge].first;
                b += offsets[edge].second;
                z--;
            }
        }
        r++;
    }
    g << a << " " << b;
}

void solve_2() {
    f >> x >> y;
    int a = 0, b = 0, z = 0, r = 1;
    while (x != a || y != b) {
        a += 1; b += 2; z++;
        for (int edge=0;edge<6 && (x != a || y != b);edge++) {
            for (int i=1; (i<(r + (edge != 0))) && (x != a || y != b); i++) {
                a += offsets[edge].first;
                b += offsets[edge].second;
                z++;
            }
        }
        r++;
    }
    g << z;
}

int main() {
    f >> c;  
    if (c == 1) solve_1();
    else solve_2();
    return 0;
}